#pragma once

#include "decoder.hpp"
#include "avdeleter.hpp"
extern "C" {
#include <libavcodec/codec_id.h>
#include <libavutil/pixfmt.h>
} //extern C

namespace mgs::ffmpeg {

class AVCodec {
public:
	AVCodec() = delete;
	explicit AVCodec (::AVCodecID id);
	~AVCodec() noexcept;

	Decoder make_decoder (unsigned int width, unsigned int height, ::AVPixelFormat dst_format);

private:
	unique_av_ptr<struct ::AVCodec> m_avcodec;
};
} //namespace mgs::ffmpeg
