#pragma once

#include <memory>

struct AVCodec;
struct AVCodecContext;
struct AVPacket;
struct AVFrame;
struct SwsContext;

namespace mgs::ffmpeg {
template <typename T>
struct AVDeleter {
	void operator()(T*) const noexcept;
};

template <typename T>
using unique_av_ptr = std::unique_ptr< T, AVDeleter<T> >;
} //namespace mgs::ffmpeg
