#include "file_handle.hpp"

#if !defined(NDEBUG)
#	include <iostream>
#endif
#include <unistd.h>
#include <fcntl.h>
//#include <sys/stat.h>

namespace mgs {
const int FileHandle::Mode_RDWR = O_RDWR;
const int FileHandle::Mode_RDONLY = O_RDONLY;
const int FileHandle::Mode_WRONLY = O_WRONLY;
const int FileHandle::Mode_APPEND = O_APPEND;
const int FileHandle::Mode_CREAT = O_CREAT;
const int FileHandle::Mode_DIRECTORY = O_DIRECTORY;
const int FileHandle::Mode_DSYNC = O_DSYNC;
const int FileHandle::Mode_EXCL = O_EXCL;
const int FileHandle::Mode_NOCTTY = O_NOCTTY;
const int FileHandle::Mode_NOFOLLOW = O_NOFOLLOW;
const int FileHandle::Mode_NONBLOCK = O_NONBLOCK;
const int FileHandle::Mode_RSYNC = O_RSYNC;
const int FileHandle::Mode_SYNC = O_SYNC;
const int FileHandle::Mode_TRUNC = O_TRUNC;

void FileHandle::Deleter::operator() (pointer fd) {
#if !defined(NDEBUG)
	std::cout << "Closing file " << static_cast<int>(fd) << '\n';
#endif
	close(fd);
}

FileHandle FileHandle::open (const char* path, int mode) {
	return {::open(path, O_RDWR)};
}

} //namespace mgs
